class ChallengeMap {
    string uid;
    string name;
    uint time;
    string timeFormatted;
    uint pb = 0;
    string pbFormatted = '';
    int delta = 0;
    string deltaFormatted = '';
    string color;
    Campaign@ campaign = null;

    ChallengeMap(string _uid, string _name, uint _time, string _color) {
        uid = _uid;
        name = _name;
        time = _time;
        timeFormatted = Time::Format(_time);
        color = _color;
    }

    void setCampaign(Campaign@ _campaign) {
        @campaign = _campaign;
    }

    bool achieved() {
        return pb > 0 && pb <= time;
    }

    void setPB(uint _pb) {
        if (_pb < 0 || _pb > 4000000000) { // assume very large numbers mean no time
            pb = 0;
        } else {
            pb = _pb;
        }

        if (pb > 0) {
            pbFormatted = Time::Format(pb);
            delta = pb - time;
            deltaFormatted = Time::Format(delta);
            if (delta > 0) {
                deltaFormatted = '\\$f55(+' + deltaFormatted + ')';
            } else {
                deltaFormatted = '\\$0f0(' + deltaFormatted + ')';
            }
        } else {
            pbFormatted = '';
            deltaFormatted = '';
        }
    }
}